require 'sketchup.rb'

def clean_edges_of(entities)

	entities.each do |ent| 
		case ent.typename
		
			when "Edge"
				ent.visible=false
			when "ComponentInstance"
				clean_edges_of(ent.definition.entities)
			when "Group"
				clean_edges_of(ent.entities)
		end
	end
end

def gather_images_in(entities)

	images = []
	entities.each do |ent| 
		case ent.typename
		
			when "Image"
				images.push(ent)
			when "ComponentInstance"
				images.concat(gather_images_in(ent.definition.entities))
			when "Group"
				images.concat(gather_images_in(ent.entities))
		end
	end
	images
end

def clean_images
	# first explode all images
	images = gather_images_in(Sketchup.active_model.entities)
	
	images.each do | image | 
		image.explode 
	end
	# then clean edges
	clean_edges_of(Sketchup.active_model.entities)
end

UI.menu("plugins").add_item("Clean Image File") { clean_images }
